Index: c/src/ada-tests/sptests/sp06/sptest.adb
===================================================================
--- c/src/ada-tests/sptests/sp06/sptest.adb	(revision 6d4e604be8b43c0555cd1c9531fe78ae199a1189)
+++ c/src/ada-tests/sptests/sp06/sptest.adb	(revision 6d4e604be8b43c0555cd1c9531fe78ae199a1189)
@@ -0,0 +1,222 @@
+--
+--  SPTEST / BODY
+--
+--  DESCRIPTION:
+--
+--  This package is the implementation of Test 6 of the RTEMS
+--  Single Processor Test Suite.
+--
+--  DEPENDENCIES: 
+--
+--  
+--
+--  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
+--  On-Line Applications Research Corporation (OAR).
+--  All rights assigned to U.S. Government, 1994.
+--
+--  This material may be reproduced by or for the U.S. Government pursuant
+--  to the copyright license under the clause at DFARS 252.227-7013.  This
+--  notice must appear in all copies of this file and its derivatives.
+--
+--  sptest.adb,v 1.3 1995/07/12 19:41:27 joel Exp
+--
+
+with INTERFACES; use INTERFACES;
+with RTEMS;
+with TEST_SUPPORT;
+with TEXT_IO;
+
+package body SPTEST is
+
+--PAGE
+-- 
+--  INIT
+--
+
+   procedure INIT (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   ) is
+      STATUS            : RTEMS.STATUS_CODES;
+      PREVIOUS_PRIORITY : RTEMS.TASK_PRIORITY;
+   begin
+
+      TEXT_IO.NEW_LINE( 2 );
+      TEXT_IO.PUT_LINE( "*** TEST 6 ***" );
+
+      SPTEST.TASK_NAME( 1 ) := RTEMS.BUILD_NAME(  'T', 'A', '1', ' ' );
+      SPTEST.TASK_NAME( 2 ) := RTEMS.BUILD_NAME(  'T', 'A', '2', ' ' );
+      SPTEST.TASK_NAME( 3 ) := RTEMS.BUILD_NAME(  'T', 'A', '3', ' ' );
+
+      SPTEST.ARGUMENT := 0;
+      SPTEST.RESTART_ARGUMENT := 1;
+
+      RTEMS.TASK_CREATE( 
+         SPTEST.TASK_NAME( 1 ), 
+         1, 
+         2048, 
+         RTEMS.DEFAULT_MODES,
+         RTEMS.DEFAULT_ATTRIBUTES,
+         SPTEST.TASK_ID( 1 ),
+         STATUS
+      );
+      TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_CREATE OF TA1" );
+
+      RTEMS.TASK_CREATE( 
+         SPTEST.TASK_NAME( 2 ), 
+         1, 
+         2048, 
+         RTEMS.DEFAULT_MODES,
+         RTEMS.DEFAULT_ATTRIBUTES,
+         SPTEST.TASK_ID( 2 ),
+         STATUS
+      );
+      TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_CREATE OF TA2" );
+
+      RTEMS.TASK_CREATE( 
+         SPTEST.TASK_NAME( 3 ), 
+         10, 
+         2048, 
+         RTEMS.DEFAULT_MODES,
+         RTEMS.DEFAULT_ATTRIBUTES,
+         SPTEST.TASK_ID( 3 ),
+         STATUS
+      );
+      TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_CREATE OF TA3" );
+
+      RTEMS.TASK_START(
+         SPTEST.TASK_ID( 1 ),
+         SPTEST.TASK_1'ACCESS,
+         0,
+         STATUS
+      );
+      TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_START OF TA1" );
+
+      RTEMS.TASK_START(
+         SPTEST.TASK_ID( 2 ),
+         SPTEST.TASK_2'ACCESS,
+         SPTEST.ARGUMENT,
+         STATUS
+      );
+      TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_START OF TA2" );
+
+      RTEMS.TASK_START(
+         SPTEST.TASK_ID( 3 ),
+         SPTEST.TASK_3'ACCESS,
+         SPTEST.ARGUMENT,
+         STATUS
+      );
+      TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_START OF TA3" );
+
+      RTEMS.TASK_SET_PRIORITY(
+         SPTEST.TASK_ID( 3 ),
+         5,
+         PREVIOUS_PRIORITY,
+         STATUS
+      );
+      TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_SET_PRIORITY OF TA3" );
+
+      RTEMS.TASK_DELETE( RTEMS.SELF, STATUS );
+      TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_DELETE OF SELF" );
+
+   end INIT;
+
+--PAGE
+-- 
+--  TASK_1
+--
+
+   procedure TASK_1 (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   ) is
+      PASS   : RTEMS.UNSIGNED32;
+      STATUS : RTEMS.STATUS_CODES;
+   begin
+
+      TEXT_IO.PUT_LINE( "TA1 - is beginning to run" );
+
+      PASS := ARGUMENT + 1;
+
+      if PASS = 5 then
+         TEXT_IO.PUT_LINE( "*** END OF TEST 6 ***" );
+         RTEMS.SHUTDOWN_EXECUTIVE( 0 );
+      end if;
+
+      if PASS = 1 then
+         TEXT_IO.PUT_LINE( "TA1 - restarting TA3" );
+         RTEMS.TASK_RESTART( 
+            SPTEST.TASK_ID( 3 ), 
+            SPTEST.RESTART_ARGUMENT, 
+            STATUS 
+         );
+         TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_RESTART OF TA3" );
+
+         RTEMS.TASK_WAKE_AFTER( 2 * TEST_SUPPORT.TICKS_PER_SECOND, STATUS );
+         TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_WAKE_AFTER" );
+
+      end if;
+
+      RTEMS.TASK_WAKE_AFTER( TEST_SUPPORT.TICKS_PER_SECOND, STATUS );
+      TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_WAKE_AFTER" );
+
+      TEXT_IO.PUT_LINE( "TA1 - task_restart - restarting TA2" );
+      RTEMS.TASK_RESTART( 
+         SPTEST.TASK_ID( 2 ), 
+         SPTEST.RESTART_ARGUMENT, 
+         STATUS 
+      );
+      TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_RESTART OF TA2" );
+
+      RTEMS.TASK_WAKE_AFTER( TEST_SUPPORT.TICKS_PER_SECOND, STATUS );
+      TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_WAKE_AFTER" );
+
+      TEXT_IO.PUT_LINE( "TA1 - task_restart - restarting self" );
+      RTEMS.TASK_RESTART( SPTEST.TASK_ID( 1 ), PASS, STATUS );
+      TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_RESTART OF SELF" );
+
+   end TASK_1;
+
+--PAGE
+-- 
+--  TASK_2
+--
+
+   procedure TASK_2 (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   ) is
+      STATUS : RTEMS.STATUS_CODES;
+   begin
+
+      TEXT_IO.PUT_LINE( "TA2 - is beginning to run" );
+
+      if ARGUMENT = SPTEST.ARGUMENT then
+         RTEMS.TASK_WAKE_AFTER( 2 * TEST_SUPPORT.TICKS_PER_SECOND, STATUS );
+         TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_WAKE_AFTER" );
+      end if;
+
+      loop
+
+         TEXT_IO.PUT_LINE( "TA2 - task_wake_after - sleep 1/2 second" );
+         RTEMS.TASK_WAKE_AFTER( TEST_SUPPORT.TICKS_PER_SECOND / 2, STATUS );
+         TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_WAKE_AFTER" );
+
+      end loop;
+
+   end TASK_2;
+
+--PAGE
+-- 
+--  TASK_3
+--
+
+   procedure TASK_3 (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   ) is
+      STATUS : RTEMS.STATUS_CODES;
+   begin
+
+      RTEMS.TASK_DELETE( RTEMS.SELF, STATUS );
+      TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_DELETE OF SELF" );
+
+   end TASK_3;
+
+end SPTEST;
Index: c/src/ada-tests/sptests/sp06/sptest.ads
===================================================================
--- c/src/ada-tests/sptests/sp06/sptest.ads	(revision 6d4e604be8b43c0555cd1c9531fe78ae199a1189)
+++ c/src/ada-tests/sptests/sp06/sptest.ads	(revision 6d4e604be8b43c0555cd1c9531fe78ae199a1189)
@@ -0,0 +1,146 @@
+--
+--  SPTEST / SPECIFICATION
+--
+--  DESCRIPTION:
+--
+--  This package is the specification for Test 6 of the RTEMS
+--  Single Processor Test Suite.
+--
+--  DEPENDENCIES: 
+--
+--  
+--
+--  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
+--  On-Line Applications Research Corporation (OAR).
+--  All rights assigned to U.S. Government, 1994.
+--
+--  This material may be reproduced by or for the U.S. Government pursuant
+--  to the copyright license under the clause at DFARS 252.227-7013.  This
+--  notice must appear in all copies of this file and its derivatives.
+--
+--  sptest.ads,v 1.3 1995/07/12 19:41:28 joel Exp
+--
+
+with CLOCK_DRIVER;
+with RTEMS;
+
+package SPTEST is
+
+--
+--  These arrays contain the IDs and NAMEs of all RTEMS tasks created
+--  by this test.
+--
+
+   TASK_ID   : array ( RTEMS.UNSIGNED32 range 1 .. 3 ) of RTEMS.ID;
+   TASK_NAME : array ( RTEMS.UNSIGNED32 range 1 .. 3 ) of RTEMS.NAME;
+
+--
+--  The following are used as arguments to the various RTEMS tasks
+--  in this test to indicate when a restart should be performed.
+
+   ARGUMENT         : RTEMS.UNSIGNED32;
+   RESTART_ARGUMENT : RTEMS.UNSIGNED32;
+
+--
+--  INIT
+--
+--  DESCRIPTION:
+--
+--  This RTEMS task initializes the application.
+--
+
+   procedure INIT (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   );
+
+--
+--  TASK_1
+--
+--  DESCRIPTION:
+--
+--  This RTEMS task tests some of the capabilities of the Task Manager.
+--
+
+   procedure TASK_1 (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   );
+
+--
+--  TASK_2
+--
+--  DESCRIPTION:
+--
+--  This RTEMS task tests some of the capabilities of the Task Manager.
+--
+
+   procedure TASK_2 (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   );
+
+--
+--  TASK_3
+--
+--  DESCRIPTION:
+--
+--  This RTEMS task tests some of the capabilities of the Task Manager.
+--
+
+   procedure TASK_3 (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   );
+
+--
+--  This is the Driver Address Table for this test.
+--
+
+   DEVICE_DRIVERS : aliased RTEMS.DRIVER_ADDRESS_TABLE( 1 .. 1 ) :=
+   (1=>
+      (
+        CLOCK_DRIVER.INITIALIZE'ACCESS,              -- Initialization
+        RTEMS.NO_DRIVER_ENTRY,                       -- Open
+        RTEMS.NO_DRIVER_ENTRY,                       -- Close
+        RTEMS.NO_DRIVER_ENTRY,                       -- Read
+        RTEMS.NO_DRIVER_ENTRY,                       -- Write
+        RTEMS.NO_DRIVER_ENTRY                        -- Control
+      )
+   );
+
+--
+--  This is the Initialization Tasks Table for this test.
+--
+
+   INITIALIZATION_TASKS : aliased RTEMS.INITIALIZATION_TASKS_TABLE( 1 .. 1 ) := 
+   (1=>
+     (
+       RTEMS.BUILD_NAME( 'U', 'I', '1', ' ' ),        -- task name
+       2048,                                          -- stack size
+       1,                                             -- priority
+       RTEMS.DEFAULT_ATTRIBUTES,                      -- attributes
+       SPTEST.INIT'ACCESS,                            -- entry point
+       RTEMS.NO_PREEMPT,                              -- initial mode
+       0                                              -- argument list
+     )
+   );
+
+--
+--  This is the Configuration Table for this test.
+--
+
+   CONFIGURATION : aliased RTEMS.CONFIGURATION_TABLE := (
+      RTEMS.NULL_ADDRESS,        -- will be replaced by BSP
+      64 * 1024,                 -- executive RAM size
+      10,                        -- maximum # tasks
+      0,                         -- maximum # timers
+      0,                         -- maximum # semaphores
+      0,                         -- maximum # message queues
+      0,                         -- maximum # messages
+      0,                         -- maximum # partitions
+      0,                         -- maximum # regions
+      0,                         -- maximum # dp memory areas
+      0,                         -- maximum # periods
+      0,                         -- maximum # user extensions
+      RTEMS.MILLISECONDS_TO_MICROSECONDS(10), -- # us in a tick
+      100                        -- # ticks in a timeslice
+  );
+
+end SPTEST;
